# Aufgabe 15, Teil 2
#
# von: Stephan Brumme, nach Vorlage
#
# zuletzt geaendert: 03.Mai 2000


# Codesegment startet an Standardadresse
	.text 0x00400000
# Einsprungpunkt global bekannt machen
	.globl main

main:

# laedt den Wert 0x55AA*2^16 (=0x55AA0000) in R07
	lui  $7,0x55AA

# vorzeichenbehaftetes OR von 0xAA55 (=-21930) mit dem Nullregister, R2=0xAA55
	ori  $2,$0,0xAA55

# R2 wird um 16 Bits nach rechts geschoben, das Ergebnis in R3 gespeichert
# da die obersten 16 Bits von R2 nicht gesetzt waren, ist R3=0
	srl  $3,$2,16

# R2 wird um 16 Bits nach links geschoben, das Ergebnis in R4 gespeichert
# da die untersten 16 Bits von R2=0xAA55 waren, ist R4=0xAA550000
	sll  $4,$2,16

# logische OR-Verknuepfung von R2 (=0xAA55) und R7 (=0x55AA0000)
# Ergebnis in R7 ist dann 0x55AAAA55
	or   $7,$7,$2

# addiert zu R7 das Nullregister, Ergebnis in R2=R7=0x55AAAA55
	add  $2,$0,$7

# dieser Befehl wird vom Assembler in 2 Befehle unterteilt:
# zuerst wird die Adresse der Daten im Datensegment in R1 geladen (=0x10010000)
# dann wird in R5 der Offset von Mem2 addiert (in diesem Falle 0), R5=0x10010000
	la   $5,Mem2

# das Datum an der Adresse von Mem2 wird in R5 geladen, R5=0x12345678
	lw   $6,0($5)

# Register R2 (=0x55AAAA55) wird 4 Bytes hinter Mem2, also in nichtinitialisiertem Speicher geschrieben
	sw   $2,4($5)

# das Programm tritt in eine Endlosschleife ein
ende:	j    ende

	
	.data
Mem1:	.word 0x12345678
Mem2:	.word 0
